// performance.now() polyfill
if (!Date.now) { Date.now = function() { return new Date().getTime(); } }
(function()
{
	if (window.performance && window.performance.now) { return; }

	window.performance = window.performance || {};

	if
	(
		window.performance.timing && window.performance.timing.navigationStart &&
		window.performance.mark &&
		window.performance.clearMarks &&
		window.performance.getEntriesByName
	)
	{
		window.performance.now = function()
		{
			window.performance.clearMarks('__PERFORMANCE_NOW__');
			window.performance.mark('__PERFORMANCE_NOW__');
			return window.performance.getEntriesByName('__PERFORMANCE_NOW__')[0].startTime;
		};
	}
	else if ("now" in window.performance === false)
	{
		var nowOffset = Date.now();

		if (window.performance.timing && window.performance.timing.navigationStart)
		{
			nowOffset = window.performance.timing.navigationStart
		}

		window.performance.now = function now()
		{
			return Date.now() - nowOffset;
		}
	}
})();

// requestAnimationframe() polyfill
(function() {
    var lastTime = 0,
        vendors = ['ms', 'moz', 'webkit', 'o'],
        x,
        length,
        currTime,
        timeToCall;

    for(x = 0, length = vendors.length; x < length && !window.requestAnimationFrame; ++x) {
        window.requestAnimationFrame = window[vendors[x]+'RequestAnimationFrame'];
        window.cancelAnimationFrame =
          window[vendors[x]+'CancelAnimationFrame'] || window[vendors[x]+'CancelRequestAnimationFrame'];
    }

    if (!window.requestAnimationFrame)
        window.requestAnimationFrame = function(callback, element) {
            currTime = new Date().getTime();
            timeToCall = Math.max(0, 16 - (currTime - lastTime));
            lastTime = currTime + timeToCall;
            return window.setTimeout(function() { callback(currTime + timeToCall); },
              timeToCall);
        };

    if (!window.cancelAnimationFrame)
        window.cancelAnimationFrame = function(id) {
            clearTimeout(id);
        };
}());

// get relative position of element in parent
function getRelativePos(elm)
{
	var pPos = elm.parentNode.getBoundingClientRect(); // parent pos
	var cPos = elm.getBoundingClientRect(); // target pos
	var pos = {};

	pos.top    = cPos.top    - pPos.top + elm.parentNode.scrollTop,
	pos.right  = cPos.right  - pPos.right,
	pos.bottom = cPos.bottom - pPos.bottom,
	pos.left   = cPos.left   - pPos.left;

	return pos;
}

// smooth scroll the contents of a div to some position
function doscroll(element,targetpos,speed)
{
	var start=element.scrollTop;
	var	change=targetpos-start;
	var duration=change/speed;
	var startTime = performance.now();
	var val, now, elapsed, t;

	function animateScroll()
	{
		now=performance.now();
		elapsed=now-startTime;
		t=elapsed/duration;
		element.scrollTop = start+t*change;
		if (t < 1)
			window.requestAnimationFrame(animateScroll);
	}

	animateScroll();
}
